/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines DEC-alpha-Rounding (DEC Alpha)
 * --------------------------------------------------------------------
 *
 * Copyright (c) 1997 Olaf Knueppel
 *
 * $Id: BiasRnd.c,v 1.2 1998/01/06 08:25:19 knueppel Exp $
 *
 ************************************************************************/

#include <BiasRnd.h>

void BiasRoundInit (void) {}

#define RND_MASK 0x0C00000000000000
#define RND_DOWN 0x0400000000000000
#define RND_NEAR 0x0800000000000000
#define RND_UP   0x0C00000000000000

void BiasRoundNear (void)
{
  register long int fpcontrol;

  asm volatile ("mf_fpcr %0" : "=f" (fpcontrol));
  fpcontrol &= ~RND_MASK;
  fpcontrol |= RND_NEAR;
  asm volatile ("mt_fpcr %0" : : "f" (fpcontrol));
}

void BiasRoundUp (void)
{
  register long int fpcontrol;

  asm volatile ("mf_fpcr %0" : "=f" (fpcontrol));
  fpcontrol &= ~RND_MASK;
  fpcontrol |= RND_UP;
  asm volatile ("mt_fpcr %0" : : "f" (fpcontrol));
}

void BiasRoundDown (void)
{
  register long int fpcontrol;

  asm volatile ("mf_fpcr %0" : "=f" (fpcontrol));
  fpcontrol &= ~RND_MASK;
  fpcontrol |= RND_DOWN;
  asm volatile ("mt_fpcr %0" : : "f" (fpcontrol));
}
