/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines Sparc-Rounding (SunOS4.1, gcc)
 * --------------------------------------------------------------------
 *
 * Copyright (c) 1997 Olaf Knueppel
 *
 * $Id: BiasRnd.h,v 1.3 1998/07/08 11:13:28 knueppel Exp $
 *
 ************************************************************************/

#ifndef __BIASRND__
#define __BIASRND__

#include <BIAS/BiasType.h>

extern const unsigned int _BiasCwRoundUp;
extern const unsigned int _BiasCwRoundDown;
extern const unsigned int _BiasCwRoundNear;

#define _BiasRoundInit()
#define _BiasRoundUp()    asm volatile ("ld %0,%%fsr" : : "g" (_BiasCwRoundUp))
#define _BiasRoundDown()  asm volatile ("ld %0,%%fsr" : : "g" (_BiasCwRoundDown))
#define _BiasRoundNear()  asm volatile ("ld %0,%%fsr" : : "g" (_BiasCwRoundNear))

#define __BIASINLINEROUNDING__

/*
 * If the following macro is defined,
 * division by zero aborts with an error message;
 * otherwise, bounds containing +/-oo
 * or NaN are computed.
 */
#define __BIASRAISEDIVIDEBYZERO__

/*
 * If the following macro is defined,
 * the rounding mode is set to nearest after
 * each interval operation.
 */
#undef  __BIASSETROUNDTONEAREST__

/*
 * The following macro defines the number of invalid bits
 * obtained by the standard C library functions (e.g. sin(), cos(), ...)
 */
#define __BIASSTDFUNCINVALIDBITS__      0

#endif /* __BIASRND__ */
