/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines 80x86-Rounding (Watcom)
 * -------------------------------------------------------------
 *
 * Copyright (c) 1998 Olaf Knueppel
 *
 * $Id: BiasRnd.h,v 1.1 1998/10/07 10:40:50 knueppel Exp $
 *
 ************************************************************************/

#ifndef __BIASRND__
#define __BIASRND__

#include <BIAS/BiasType.h>

#undef __BIASINLINEROUNDING__

/*
 * If the following macro is defined,
 * division by zero aborts with an error message;
 * otherwise, bounds containing +/-oo
 * or NaN are computed.
 */
#undef __BIASRAISEDIVIDEBYZERO__

/*
 * If the following macro is defined,
 * the rounding mode is set to nearest after
 * each interval operation.
 */
#define  __BIASSETROUNDTONEAREST__

/*
 * The following macro defines the number of invalid bits
 * obtained by the standard C library functions (e.g. sin(), cos(), ...)
 */
#define __BIASSTDFUNCINVALIDBITS__      0

#ifdef __cplusplus
extern "C" {
#endif

void BiasRoundInit (void);
void BiasRoundUp   (void);
void BiasRoundDown (void);
void BiasRoundNear (void);

#ifdef __cplusplus
}
#endif

#endif /* __BIASRND__ */
