/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines Internal Definitions
 * ----------------------------------------------------------
 *
 * Copyright (c) 1993, 1994, 1997 Olaf Knueppel
 *
 * $Id: BiasInt.h,v 1.2 1997/12/10 13:09:09 knueppel Exp $
 *
 ************************************************************************/

#ifndef __BIASINTERN__
#define __BIASINTERN__

/************************************************************************
 *  Macros
 ************************************************************************/

#if defined (__INTEGERCOMPARE__)
#if defined (__BIGENDIAN__)
#define SIGNIDX 0
#else
#define SIGNIDX (sizeof (REAL) / sizeof (unsigned long) - 1)
#endif
#define SIGNBIT (1L << (8 * sizeof (unsigned long) - 1))

#define Sign(r) \
        (((unsigned long *) & (r)) [SIGNIDX] & SIGNBIT)

#define Zero(r) \
        ((sizeof (REAL) == sizeof (unsigned long) ?              \
        (((unsigned long *) & (r)) [SIGNIDX] & ~ SIGNBIT) :      \
        (((unsigned long *) & (r)) [SIGNIDX] & ~ SIGNBIT) |      \
        ((unsigned long *) & (r)) [1 - SIGNIDX]) == 0)
#else /* __INTEGERCOMPARE__ */
#define Sign(r) ((r) < 0.0)
#define Zero(r) ((r) == 0.0)
#endif /* __INTEGERCOMPARE__ */

#if defined (__BIASSETROUNDTONEAREST__)
#define _SetRoundToNearest()    _BiasRoundNear ()
#else
#define _SetRoundToNearest()
#endif

#if !defined (__BIASINLINEROUNDING__)
#define _BiasRoundInit()        BiasRoundInit ()
#define _BiasRoundUp()          BiasRoundUp ()
#define _BiasRoundDown()        BiasRoundDown ()
#define _BiasRoundNear()        BiasRoundNear ()
#endif

/************************************************************************
 *  Subroutines
 ************************************************************************/

VOID _BiasError (const char * const s);

#endif /* __BIASINTERN__ */
