/************************************************************************
 *
 * General Configuration Parameters
 * --------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: Configuration.h,v 1.3 1999/07/28 08:55:11 knueppel Exp $
 *
 ************************************************************************/

#ifndef __CONFIG__
#define __CONFIG__

/************************************************************************
 *  If the following macro is defined, a special strategy avoiding
 *  copies of temporary structures is used. Due to the fact, that C++
 *  only supports a single copy constructor, some restrictions occur when
 *  using this strategy:
 *    - expressions must not be used as reference parameters
 *    - expressions or single variables must not be used as value parameters
 *    - initialization without using the assignment operator must not
 *      be used.
 *  The above restrictions are valid for all structured types as VECTOR,
 *  MATRIX, INTERVAL_VECTOR, ...
 *  If any of the above cases can't be avoided, a MakePermanent(...)
 *  command must be used before any use of the appropriate variable.
 *  For testing purposes, the macro should be left undefined.
 ************************************************************************/

#undef __DONTCOPY__

/************************************************************************
 *  If the following macro is defined, an index check is performed prior
 *  any vector or matrix element access. This results in reduced execution
 *  speed and therefore should only be used in the developement phase
 * of the program.
 *************************************************************************/

#undef __INDEXCHECK__

/************************************************************************
 *  If the following macro is defined, the keyword 'const' is used.
 *  If you have an older compiler which gets into trouble with this,
 *  replace the definition below by:
 *  #undef __USECONST__
 *************************************************************************/

#define __USECONST__

/************************************************************************
 *  Include some general definitions
 *************************************************************************/

#include <Definitions.h>

#endif /* __CONFIG__ */
