/************************************************************************
 *
 * Implementation of machine dependant constants
 * ---------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: Constants.C,v 1.1 1997/09/23 11:50:52 knueppel Exp $
 *
 ************************************************************************/

static char rcs_id[] = "$Id: Constants.C,v 1.1 1997/09/23 11:50:52 knueppel Exp $";

#include <Constants.h>
#include <BIAS/Bias0.h>

REAL Machine::Epsilon            = 0.0;
REAL Machine::MinPositive        = 0.0;
REAL Machine::PosInfinity        = 0.0;
REAL Machine::NegInfinity        = 0.0;
REAL Machine::NaN                = 0.0;

Machine MachineConstants; // constructor is called automatically

Machine::Machine ()
{
  BiasInit ();
  Machine::Epsilon            = BiasEpsilon;
  Machine::MinPositive        = BiasEta;
  Machine::PosInfinity        = BiasPosInf;
  Machine::NegInfinity        = BiasNegInf;
  Machine::NaN                = BiasNaN;
}

// The following routine is only used for reference in Interval.C and Vector.C
// in order to force the loader to bind this file into the executable code.

VOID RegisterConstants () { }
