/************************************************************************
 *
 * Definition of operations with exact scalar product
 * --------------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: HighPrec.h,v 1.1 1997/09/23 11:50:53 knueppel Exp $
 *
 ************************************************************************/

#ifndef __HIGHPREC__
#define __HIGHPREC__

#include <IntervalMatrix.h>
#include <lr/Li.h>

REAL   HighPrecMul (CONST VECTOR &, CONST VECTOR &);
VECTOR HighPrecMul (CONST MATRIX &, CONST VECTOR &);
MATRIX HighPrecMul (CONST MATRIX &, CONST MATRIX &);

INTERVAL HighPrecMulBounds (CONST VECTOR &         , CONST VECTOR &         );
INTERVAL HighPrecMul       (CONST VECTOR &         , CONST INTERVAL_VECTOR &);
INTERVAL HighPrecMul       (CONST INTERVAL_VECTOR &, CONST VECTOR &         );
INTERVAL HighPrecMul       (CONST INTERVAL_VECTOR &, CONST INTERVAL_VECTOR &);

INTERVAL_VECTOR HighPrecMulBounds (CONST MATRIX &         , CONST VECTOR &         );
INTERVAL_VECTOR HighPrecMul       (CONST MATRIX &         , CONST INTERVAL_VECTOR &);
INTERVAL_VECTOR HighPrecMul       (CONST INTERVAL_MATRIX &, CONST VECTOR &         );
INTERVAL_VECTOR HighPrecMul       (CONST INTERVAL_MATRIX &, CONST INTERVAL_VECTOR &);

INTERVAL_MATRIX HighPrecMulBounds (CONST MATRIX &         , CONST MATRIX &         );
INTERVAL_MATRIX HighPrecMul       (CONST MATRIX &         , CONST INTERVAL_MATRIX &);
INTERVAL_MATRIX HighPrecMul       (CONST INTERVAL_MATRIX &, CONST MATRIX &         );
INTERVAL_MATRIX HighPrecMul       (CONST INTERVAL_MATRIX &, CONST INTERVAL_MATRIX &);

INTERVAL_MATRIX IdMinusHighPrecMul (CONST MATRIX &         , CONST MATRIX &         );
INTERVAL_MATRIX IdMinusHighPrecMul (CONST MATRIX &         , CONST INTERVAL_MATRIX &);
INTERVAL_MATRIX IdMinusHighPrecMul (CONST INTERVAL_MATRIX &, CONST MATRIX &         );
INTERVAL_MATRIX IdMinusHighPrecMul (CONST INTERVAL_MATRIX &, CONST INTERVAL_MATRIX &);

// the following functions are for internal use only!
LREAL  HighPrecScalpLr (CONST REAL *, CONST REAL *, INT, INT);
LIREAL HighPrecScalpLi (CONST REAL *, CONST REAL *, INT, INT);
LIREAL HighPrecScalpLi (CONST REAL *, CONST BIASINTERVAL *, INT, INT);
LIREAL HighPrecScalpLi (CONST BIASINTERVAL *, CONST REAL *, INT, INT);
LIREAL HighPrecScalpLi (CONST BIASINTERVAL *, CONST BIASINTERVAL *, INT, INT);

#endif /* __HIGHPREC__ */
