/************************************************************************
 *
 * Implementation of nice INTERVAL input and output
 * ------------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: NiceIntervalIO.C,v 1.2 1998/07/15 08:16:21 knueppel Exp $
 *
 ************************************************************************/

static const char rcs_id[] = "$Id: NiceIntervalIO.C,v 1.2 1998/07/15 08:16:21 knueppel Exp $";

#if !defined (__SIMPLEINOUT__)

#include <LongInterval.h>

static LREAL  LongInfimum = NULL;
static LREAL  LongSupremum = NULL;
static LIREAL LongInterval = NULL;

// The prototype for the input/output functions
// are defined in Interval.h

ostream & operator << (ostream & os, CONST INTERVAL & iv)
{
  REAL Infimum, Supremum;

  Infimum = Inf (iv); Supremum = Sup (iv);
  if (LongInfimum == NULL) {
    LongInfimum  = LrNewVar (6);
    LongSupremum = LrNewVar (6);
    LongInterval = LiNewTemp (6, 1);
  }
  else {
    LrSetPosDigits (LongInfimum, 6);
    LrSetPosDigits (LongSupremum, 6);
    LiInfo (LongInterval) = 6;
  }
  dtolr (LongInfimum, & Infimum); dtolr (LongSupremum, & Supremum);
  LiHull (LongInfimum, LongSupremum, LongInterval, 0);
  LiToOutput (os, LongInterval);
  return os;
}

istream & operator >> (istream & is, INTERVAL & x)
{
  CHAR sz[1024];

  is >> sz;
  x = Enclosure (sz);
  return is;
}

// The following code is only used to force LongReal.C to be
// always included in the executable code.

extern VOID RegisterLongReal ();

VOID RegisterNiceIntervalOutput () { RegisterLongReal (); }

#endif
