/************************************************************************
 *
 * Definition of commonly used real operations
 * -------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: RealOp.h,v 1.1 1997/09/23 11:50:54 knueppel Exp $
 *
 ************************************************************************/

#ifndef __REALOP__
#define __REALOP__

#include <Configuration.h>

#if defined (__cplusplus)
extern "C" {
#endif

VOID RealOpNeg (REAL *pr, CONST REAL *pa, INT dim);

VOID RealOpAdd (REAL *pr, CONST REAL *pa, CONST REAL *pb, INT dim);
VOID RealOpSub (REAL *pr, CONST REAL *pa, CONST REAL *pb, INT dim);
VOID RealOpMul (REAL *pr, REAL  a,        CONST REAL *pb, INT dim);
VOID RealOpDiv (REAL *pr, CONST REAL *pa, REAL  b,        INT dim);

VOID RealOpAddTo   (REAL *pr, CONST REAL *pa, INT dim);
VOID RealOpSubFrom (REAL *pr, CONST REAL *pa, INT dim);
VOID RealOpMulWith (REAL *pr, REAL  a,        INT dim);
VOID RealOpDivBy   (REAL *pr, REAL  a,        INT dim);

REAL RealOpScalp (CONST REAL *pa, CONST REAL *pb, INT dim);

VOID RealOpVecMul (REAL *pr, CONST REAL *pa, CONST REAL *pb,
                   INT rows, INT cols);
VOID RealOpMatMul (REAL *pr, CONST REAL *pa, CONST REAL *pb,
		   INT arows, INT acols, INT bcols);

INT RealOpLessThan     (CONST REAL *pa, CONST REAL *pb, INT dim);
INT RealOpLessEqual    (CONST REAL *pa, CONST REAL *pb, INT dim);
INT RealOpGreaterThan  (CONST REAL *pa, CONST REAL *pb, INT dim);
INT RealOpGreaterEqual (CONST REAL *pa, CONST REAL *pb, INT dim);

#if defined (__cplusplus)
}
#endif

#endif /* __REALOP__ */
