/************************************************************************
 *
 * Simple Automatic Differentiation Test Program
 * ---------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: TestAutoDiff.C,v 1.1 1997/09/23 11:52:01 knueppel Exp $
 *
 ************************************************************************/

#include <AutoDiff/AutoDiff.h>

AUTODIFF TestFunction (VECTOR & v)
{
  AUTODIFF x(v);

  return Sqr (x(1)) - x(2);
}

int main()
{
  VECTOR x(2);
  x(1) = 2.0;
  x(2) = 3.0;

  cout << "f:x -> x1^2 - x2" << endl;
  cout << "f(2.0,3.0) = " << FunctionValue (TestFunction (x)) << endl;
  cout << "f'(2.0,3.0) = " << GradientValue (TestFunction (x)) << endl;
  return 0;
}
