/************************************************************************
 *
 * Definition of Expansion Strategy
 * --------------------------------
 *
 * Copyright (c) 1995, 1997 Olaf Knueppel
 *
 * $Id: Expand.h,v 1.1 1997/09/23 11:52:10 knueppel Exp $
 *
 ************************************************************************/

#ifndef __EXPAND__
#define __EXPAND__

#include <IntervalMatrix.h>
#include <Boolean.h>
#include <NLF/NLF.h>

BOOL ExpansionStep (FUNCTION & f, CONST INTERVAL_VECTOR & MaxRange,
                    CONST VECTOR & x, INTERVAL_VECTOR & Enclosure, INTERVAL_VECTOR & Expansion);
// Expansion Strategy
// Input:  x: approximation of a stationary point of f
// Output: Enclosure: narrow enclosure of a stationary point of f
//         Expansion: expansion around a  stationary point of f
// Return: TRUE, if enclosure was possible

#endif /* __EXPAND__ */
