/************************************************************************
 *
 * Definition of Unconstrained Minimization Algorithm
 * --------------------------------------------------
 *
 * Copyright (c) 1995, 1997 Olaf Knueppel
 *
 * $Id: UnconstrainedOpt.h,v 1.1 1997/09/23 11:52:10 knueppel Exp $
 *
 ************************************************************************/

#ifndef __UNCONSTOPT__
#define __UNCONSTOPT__

#include <Boolean.h>
#include <NLF/NLF.h>
#include <GlobalOpt/AppList.h>
#include <GlobalOpt/VecList.h>

VOID UnconstrainedOptimization (SOLUTIONLIST & SolutionList,
				APPROXIMATIONLIST & ApproximationList,
				INT Iterations, INT BranchLevels, REAL Eps,
				REAL RaiseFactor, REAL HeuristicExpandFactor,
				REAL & LowerBound, REAL & UpperBound,
				BOOL UseDerivatives = FALSE);

VOID StartUnconstrainedOptimization (SOLUTIONLIST & SolutionList,
				     APPROXIMATIONLIST & ApproximationList,
				     INT Iterations, INT BranchLevels, REAL Eps,
				     REAL RaiseFactor, REAL HeuristicExpandFactor,
				     REAL & LowerBound, REAL & UpperBound,
				     CONST INTERVAL_VECTOR & TheDomain,
                                     FUNCTION & TheFunction,
                                     BOOL UseDerivatives = FALSE);

VOID CleanUpLists (SOLUTIONLIST & SolutionList,
		   APPROXIMATIONLIST & ApproximationList,
		   REAL Eps, REAL LowerBound, REAL UpperBound);

VOID UpdateLowerBound (SOLUTIONLIST & SolutionList, REAL & LowerBound);

#endif /* __UNCONSTOPT__ */

