/************************************************************************
 *
 * Definition of Solution List
 * ---------------------------
 *
 * Copyright (c) 1995, 1997 Olaf Knueppel
 *
 * $Id: VecList.h,v 1.2 1997/09/25 09:18:26 knueppel Exp $
 *
 ************************************************************************/

#ifndef __VECLIST__
#define __VECLIST__

#include <IntervalMatrix.h>
#include <Boolean.h>

class SOLUTIONLIST_ELEMENT {
 public:
  INTERVAL        FunctionValue;
  INTERVAL_VECTOR Box;
  SOLUTIONLIST_ELEMENT() {};
  SOLUTIONLIST_ELEMENT (CONST INTERVAL &, CONST INTERVAL_VECTOR &);
  SOLUTIONLIST_ELEMENT & operator = (CONST SOLUTIONLIST_ELEMENT &);
  friend ostream & operator << (ostream &, CONST SOLUTIONLIST_ELEMENT &);
};

#undef LISTOBJECT
#undef LIST
#undef LIST_ELEMENT
#undef LISTCMPFUNC
#define LISTCMPFUNC  SOLUTIONLIST_CMPFUNC
#define LIST_ELEMENT SOLUTIONLIST_ELEMENT
#define LIST         SOLUTIONLIST
#define LISTOBJECT   SOLUTIONLISTOBJECT
#include <Lists/LinearList.hgen>

BOOL SolutionCmp (CONST SOLUTIONLIST_ELEMENT &, CONST SOLUTIONLIST_ELEMENT &);
VOID Cleanup (SOLUTIONLIST &, REAL);
REAL Lowest (SOLUTIONLIST &);

VOID Append (SOLUTIONLIST &, CONST INTERVAL_VECTOR &, CONST INTERVAL &);
VOID Insert (SOLUTIONLIST &, CONST INTERVAL_VECTOR &, CONST INTERVAL &);
VOID Append_First (SOLUTIONLIST &, CONST INTERVAL_VECTOR &, CONST INTERVAL &);
VOID Append (SOLUTIONLIST &, SOLUTIONLIST &);

#endif /* _VECLIST */



