/************************************************************************
 *
 * Simple Test Program for Nelder's and Mead's Minimization Method
 * ---------------------------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: TestNelderMead.C,v 1.2 1999/07/28 08:56:21 knueppel Exp $
 *
 ************************************************************************/

#include <LocalOpt/NelderMead.h>
#include <Functions.h>
#include <Error.h>

REAL f(CONST VECTOR & x)
{
  return Sqr(x(1) - 1.0) + Sqr(x(2) - 2.0) + 1.0;
}

main()
{
  VECTOR x(2); x(1) = 6.0; x(2) = 3.0;
  VECTOR d(2); d(1) = 20.0; d(2) = 20.0;
  VECTOR solution(2); solution(1) = 1.0; solution(2) = 2.0;
  REAL tol = 1E-12;
  REAL y;
  INT ok;

  y = NelderMead (x, d, tol, tol, ok, 100, f);
  if (!ok || (Norm (x - solution) > sqrt(tol) * 10.0)) {
    cout << "NelderMead: ok   = " << ok << " should be 1" << endl;
    cout << "            x    = " << x  << " should be " << solution << endl;
    cout << "            f(x) = " << y  << " should be " << f(solution) << endl;
    Error ("Problems in NelderMead_Test", 1, ErrorHandler::SevereError);
  }
  return 0;
}
