/************************************************************************
 *
 * Definition of REAL test matrices (C routines)
 * ---------------------------------------------
 *
 * Copyright (c) 1993 Thomas Simenec
 *
 * $Id: BaseTestMatrices.h,v 1.1 1997/09/23 11:54:16 knueppel Exp $
 *
 ************************************************************************/

#ifndef __BASETESTMATRICES__
#define __BASETESTMATRICES__

#include <Configuration.h>

#if defined (__cplusplus)
extern "C" {
#endif

VOID BaseLietzke (REAL *, INT);

VOID BaseIntPascal (REAL *, INT);

VOID BasePascal (REAL *, INT, REAL);

VOID BaseHilbert (REAL *, INT);

INT BaseExactHilbert (REAL *, INT);

VOID BaseInverseHilbert (REAL *, INT);

VOID BaseLotkin (REAL *, INT);

VOID BaseWestlake (REAL *, INT);

VOID BaseNewman (REAL *, INT);

VOID BaseFrank (REAL *, INT);

VOID BaseBoothroydMax (REAL *, INT);

VOID BaseHadamard (REAL *, INT);

VOID BaseBinomial (REAL *, INT);

VOID BaseAergerter (REAL *, INT);

VOID BaseTodd (REAL *, INT);

VOID BaseMilnes (REAL *, REAL *, INT, INT);

VOID BaseCombinatorial (REAL *, REAL, REAL, INT, INT);

VOID BaseCauchy (REAL *, REAL *, REAL *, INT, INT);

VOID BaseVandermonde (REAL *, REAL *, INT);

VOID BaseBoothroyd (REAL *, REAL *, REAL *, INT);

VOID BaseInverseBoothroyd (REAL *, REAL *, REAL *, INT);

VOID BaseRandomM_Matrix (REAL *, REAL *, REAL *, INT);

VOID BaseRandomPD (REAL *, REAL *, REAL *, REAL *, REAL, REAL, INT, INT);

VOID BaseRandomSPD (REAL *, REAL *, REAL *, REAL, REAL, INT, INT);

VOID BaseRandomToeplitz (REAL *, REAL *, INT);

VOID BaseRandomMatrix (REAL *, INT);

VOID BaseRectRandomMatrix (REAL *, INT, INT);

VOID BaseRandomSymmetric (REAL *, INT);

VOID BaseRandomPersymmetric (REAL *, INT);

#if defined (__cplusplus)
}
#endif

#endif /* __BASETESTMATRICES__ */
