#########################################################################
#
# PROFIL/BIAS Makefile Rules (GNU make)
# -------------------------------------
#
# $Id: Rules.mak,v 1.5 1998/09/24 13:13:01 knueppel Exp $
#
#########################################################################

LIBDIR		= $(BASEDIR)/lib
INCLUDEDIR	= $(BASEDIR)/include
ARCHDIR		= $(BASEDIR)/config/$(ARCH)

SRCDIR		= $(BASEDIR)/src
INCLUDE		= . $(SRCDIR) $(SRCDIR)/Base $(SRCDIR)/Packages $(MOREINCLUDES)
LINKEXAMPLELIBS	= $(addprefix -l,$(EXAMPLELIBS))
LIBRARYBASE	= lib$(notdir $(LIBRARY)).a
LIBRARYNAME	= $(dir $(LIBRARY))$(LIBRARYBASE)

ifneq ($(strip $(LIBRARY)),)
all:			$(LIBRARYNAME)
else
all:
endif

$(LIBRARYNAME):		$(LIBRARYNAME)($(OBJECTS))
	$(RANLIB) $@

$(LIBRARYNAME)(%.o):	%.o
	$(AR) $@ $<

ifneq ($(strip $(IAS)),)
%.o:			%.c
	$(CC) $(CFLAGS) $(DEFINES) $(addprefix -I,$(INCLUDE)) $(IASFLAGS) -o $(basename $@).is -c $<
	$(IAS) -o $(basename $@).isc $(basename $@).is
	$(AS) -o $@ $(basename $@).isc
	$(RM) $(basename $@).is $(basename $@).isc

%.o:			%.C
	$(CCPLUS) $(CPLUSFLAGS) $(DEFINES) $(addprefix -I,$(INCLUDE)) $(IASFLAGS) -o $(basename $@).is -c $<
	$(IAS) -o $(basename $@).isc $(basename $@).is
	$(AS) -o $@ $(basename $@).isc
	$(RM) $(basename $@).is $(basename $@).isc
else
%.o:			%.c
	$(CC) $(CFLAGS) $(DEFINES) $(addprefix -I,$(INCLUDE)) -o $@ -c $<

%.o:			%.C
	$(CCPLUS) $(CPLUSFLAGS) $(DEFINES) $(addprefix -I,$(INCLUDE)) -o $@ -c $<
endif

%.o:			%.s
	$(AS) -o $@ $<

%$(TESTEXT):		%.o
	$(LINK) $(LINKFLAGS) -o $@ $< -L$(LIBDIR) $(LINKEXAMPLELIBS) $(SYSLIBS)

examples:		install $(addsuffix $(TESTEXT),$(EXAMPLES))

clean:
	-@$(RM) $(LIBRARYNAME) $(OBJECTS) $(addsuffix $(TESTEXT),$(EXAMPLES))

install:		all
ifneq ($(strip $(LIBRARY)),)
	-@test -d $(LIBDIR)                   || mkdir $(LIBDIR)
endif
	-@test -d $(INCLUDEDIR)               || mkdir $(INCLUDEDIR)
	-@test -d $(INCLUDEDIR)/$(INSTALLDIR) || mkdir $(INCLUDEDIR)/$(INSTALLDIR)
ifneq ($(strip $(LIBRARY)),)
	$(INSTALL) $(LIBRARYNAME) $(LIBDIR)
	$(RANLIB) $(LIBDIR)/$(LIBRARYBASE)
endif
	$(INSTALL) $(INCLUDES) $(INCLUDEDIR)/$(INSTALLDIR)

uninstall:
	-@$(RM) $(LIBDIR)/$(LIBRARYBASE)
	-@$(RM) $(addprefix $(INCLUDEDIR)/$(INSTALLDIR)/,$(INCLUDES))
	-@$(RMDIR) $(INCLUDEDIR)/$(INSTALLDIR)
	-@$(RMDIR) $(INCLUDEDIR)
	-@$(RMDIR) $(LIBDIR)

register:
	-@mkdir RCS
	@set allow_null_glob_expansion; \
	 for file in *.[cCSh] Makefile; do \
	  echo Registering $$file; \
	  ci -u -t- $$file; \
	 done

#
# Local Variables:
# mode: Makefile
# End:
#
