/************************************************************************
 *
 * Multiple Precision Arithmetic Basic Definitions (Implementation)
 * ----------------------------------------------------------------
 *
 * $Id$
 *
 ************************************************************************/

#ifndef __PORTAB__
#define __PORTAB__

#include <lr/LrDefs.h>

#ifndef __ANSI__
#define __ANSI__
#endif
#define __32BIT__

#if defined (__LITTLEENDIAN__)

#define LO		0
#define HI		1

#define D0OF2		0
#define D1OF2		1

#define D0OF4		0
#define D1OF4		1
#define D2OF4		2
#define D3OF4		3

#define D0OF8		0
#define D1OF8		1
#define D2OF8		2
#define D3OF8		3
#define D4OF8		4
#define D5OF8		5
#define D6OF8		6
#define D7OF8		7

#elif defined (__BIGENDIAN__)

#define LO		1
#define HI		0

#define D0OF2		1
#define D1OF2		0

#define D0OF4		3
#define D1OF4		2
#define D2OF4		1
#define D3OF4		0

#define D0OF8		7
#define D1OF8		6
#define D2OF8		5
#define D3OF8		4
#define D4OF8		3
#define D5OF8		2
#define D6OF8		1
#define D7OF8		0

#endif /* !__LITTLEENDIAN__ && !__BIGENDIAN__ */

#define MoveFarLeft(pDest, pSrc, Count, Type) \
	memmove ((pDest), (pSrc), (Count) * sizeof (Type))
#define MoveFarRight(pDest, pSrc, Count, Type) \
	memmove ((pDest), (pSrc), (Count) * sizeof (Type))
#define	MoveLeft(pType,	Count, Type) \
	memmove	((pType), (pType)+1, (Count) * sizeof (Type))
#define	MoveRight(pType, Count,	Type) \
	memmove	((pType)+1, (pType), (Count) * sizeof (Type))

#define raise		goto
#define loop		for (;;)
#define min(a,b)        (((a) < (b)) ? (a) : (b))
#define max(a,b)        (((a) > (b)) ? (a) : (b))
#define dimof(array)	(sizeof(array) / sizeof(*(array)))

#if defined (__BORLANDC__)
#define _asm		asm
#endif

#endif /* !__PORTAB__ */
